clear all
close all
clc

filename = '../tests/aa.msh';
[Nodes,Elements] = readMshFile(filename);


figure
hold on
for i=1:size(Nodes,1)
    
    
end

for i=1:size(Elements,1)
    switch Elements(i,1)
        case 1
            %segment
            plot3([Nodes(Elements(i,end-1),1),Nodes(Elements(i,end),1)],...
                  [Nodes(Elements(i,end-1),2),Nodes(Elements(i,end),2)],...
                  [Nodes(Elements(i,end-1),3),Nodes(Elements(i,end),3)],'k');
        case 2
            %triangle
            for j=1:3
                plot3([Nodes(Elements(i,end-j),1),Nodes(Elements(i,end-j+1),1)],...
                      [Nodes(Elements(i,end-j),2),Nodes(Elements(i,end-j+1),2)],...
                      [Nodes(Elements(i,end-j),3),Nodes(Elements(i,end-j+1),3)],'k');
            end
        case 3
            %quadrangle
            for j=1:4
                index1 = size(Elements,2)-j;
                if j==4
                    index1 = size(Elements,2);
                end
                index2 = size(Elements,2)-j+1;
                plot3([Nodes(Elements(i,index1),1),Nodes(Elements(i,index2),1)],...
                      [Nodes(Elements(i,index1),2),Nodes(Elements(i,index2),2)],...
                      [Nodes(Elements(i,index1),3),Nodes(Elements(i,index2),3)],'k');
            end
        case 5
            %hexahedron
            for j=1:4
                index1 = size(Elements,2)-j;
                if j==4
                    index1 = size(Elements,2);
                end
                index2 = size(Elements,2)-j+1;
                plot3([Nodes(Elements(i,index1),1),Nodes(Elements(i,index2),1)],...
                      [Nodes(Elements(i,index1),2),Nodes(Elements(i,index2),2)],...
                      [Nodes(Elements(i,index1),3),Nodes(Elements(i,index2),3)],'k');
            end 
            for j=1:4
                index1 = size(Elements,2)-j-4;
                if j==4
                    index1 = size(Elements,2)-4;
                end
                index2 = size(Elements,2)-j-3;
                plot3([Nodes(Elements(i,index1),1),Nodes(Elements(i,index2),1)],...
                      [Nodes(Elements(i,index1),2),Nodes(Elements(i,index2),2)],...
                      [Nodes(Elements(i,index1),3),Nodes(Elements(i,index2),3)],'k');
            end  
            for j=1:4
                index1 = size(Elements,2)-j-4;
                if j==4
                    index1 = size(Elements,2)-4;
                end
                index2 = size(Elements,2)-j;
                if j==4
                    index2 = size(Elements,2);
                end
                plot3([Nodes(Elements(i,index1),1),Nodes(Elements(i,index2),1)],...
                      [Nodes(Elements(i,index1),2),Nodes(Elements(i,index2),2)],...
                      [Nodes(Elements(i,index1),3),Nodes(Elements(i,index2),3)],'k');
            end              
    end
    
end
axis equal