close all
clc
clear all
[it_1g, res_1g] = read_belos('multi_low_frequence_belos.text');
[it_2g, res_2g] = read_belos('multi_high_frequence_belos.text');

[it_3g, res_3g] = read_belos('multi_low_frequence_belos2.text');
[it_4g, res_4g] = read_belos('multi_high_frequence_belos2.text');
[it_5g, res_5g] = read_belos('multiFGuess_belos.text');
[it_6g, res_6g] = read_belos('multiF2Guess_belos.text');

[it_1e, res_1e] = read_belos('multi_frequence_ensemble1_belos.text');
[it_2e, res_2e] = read_belos('multi_frequence_ensemble2_belos.text');

[it_3e, res_3e] = read_belos('multi_frequence_ensemble3_belos.text');
[it_4e, res_4e] = read_belos('multi_frequence_ensemble4_belos.text');


%%
close all
figure
semilogy(it_1g, res_1g,'o','LineWidth',1,...
    'MarkerSize',8,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','r')
hold on
semilogy(it_2g, res_2g,'o','LineWidth',1,...
    'MarkerSize',8,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','g')
semilogy(it_3g, res_3g,'s','LineWidth',1,...
    'MarkerSize',8,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','r')
semilogy(it_4g, res_4g,'s','LineWidth',1,...
    'MarkerSize',8,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','g')
semilogy(it_5g, res_5g,'s','LineWidth',1,...
    'MarkerSize',8,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','b')
grid on
box on
set(gca,'fontsize',18)
xlabel('Iteration')
ylabel('(2-Norm Res Vec) / (2-Norm Prec Res0)')
hold off

figure
semilogy(it_1g, res_1g,'r','LineWidth',2)
hold on
semilogy(it_2g, res_2g,'g','LineWidth',2)
semilogy(it_1e, res_1e,'o','LineWidth',0.5,...
    'MarkerSize',16,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','r')
semilogy(it_2e, res_2e,'o','LineWidth',0.5,...
    'MarkerSize',16,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','g')
semilogy(it_3e, res_3e,'s','LineWidth',0.5,...
    'MarkerSize',8,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','r')
semilogy(it_4e, res_4e,'s','LineWidth',0.5,...
    'MarkerSize',8,...
    'MarkerEdgeColor','k',...
    'MarkerFaceColor','g')

grid on
box on
set(gca,'fontsize',18)
xlabel('Iteration')
ylabel('(2-Norm Res Vec) / (2-Norm Prec Res0)')
hold off
