#!/bin/bash
# Submission script for Blake
#SBATCH --job-name=test_2
#SBATCH --time=41:00:00 # hh:mm:ss
#
#SBATCH -N 1
#SBATCH -p blake
#
#SBATCH --comment=test
#SBATCH --output=workspace/test_2.%j.out

. ~/.bash_profile $SLURM_SUBMIT_HOST

export MKL_DYNAMIC=TRUE
export OMP_DYNAMIC=FALSE
export OMP_NUM_THREADS=24
export KMP_HW_SUBSET=24c,1t
export KMP_AFFINITY=compact

export MKL_NUM_THREADS=${OMP_NUM_THREADS}

python run.py -k ${OMP_NUM_THREADS} katoptron/thesis/test_2/1_cube.py